#made by tak2hata  http://onigiriburning.so.land.to/
#made since 2009/10/25
#Exporter For Vidro Render  http://www.vidro-project.com/
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.

#this script require 'su2objmtl.rb'
#照明周りを整理して、エリアライトのノイズのできにくい方法を考えた。特に天井照明（鉛直真下向きのみ）CIELLIGHTとマテリアル名に使う
#update:Jan 03,2013.全体的に改善。ダイアログの改善。レンダリングパラメータの保存、復元。マテリアルエディタを作成。
#update:Jan 13,2013.マテリアルエディタ周りを更新。ほぼ完成形でバージョン3.0
#今後の予定としてはコンポーネント置き換えに対応する。（スケッチアップ上で軽量なデータを配置し、Vidroには代替えのOBJファイルを読ませる。
#update:Jan 16,2013:Diffuseの強さを設定できるようにした。テクスチャの収集機能とモデルと同じフォルダにあるテクスチャの参照機能を付けた。
#update:Jan 17,2013:バグってたので修正。Diffuseの強さ関係がうまく反映できないでエクスポートされていた。
#update:Feb,19,2013:improve for 000additionalpluginfolders.
require 'su2objmtl'
class SU2VIDRO < SU2RENDER
	def make_material_thumb()
		thisdir = File.dirname(File.expand_path(__FILE__))
		jap2englist
		setting_init
		get_objmtl_ini( File.basename(__FILE__) )
		localsetting_init
		@export_dir = File.join( thisdir , "su2objmtl/mat_scene/")
		@texture_exportpath = @export_dir
		@textures_prefix = ""
		cmat = Sketchup.active_model.materials.current
		cmatname =  enc_kconv(cmat.name)
		@s2v_used_material = []
		@s2v_used_material.push cmat
		export_textures "cm_only"

		matscene_basefile = File.join( thisdir , "su2objmtl/mat_scene/mat_scene.vdr")
		Dir.chdir(thisdir)
		tbuff_arr = []
		searchfiles = File.join( @export_dir , "*.hdr\0*.exr")
		hdrname = '""'
		Dir::glob( searchfiles ).each {|fhdr|
			hdrname = '"' + File::basename(fhdr ) + '"'
		}
		if FileTest.exist?(matscene_basefile)
			msb_file=File.new(matscene_basefile,"r")
	  		msb_file.each{|line_p|
	  			line = line_p#%(#{line_p})
	  			tbuff_arr.push line.chomp
	  		}
	  		msb_file.close
			scenefile = File.join( thisdir , "su2objmtl/mat_scene/mat_scene2.vdr")
			scenefile.gsub!(/\//,'\\')
			Sketchup.set_status_text "creat material scene_file"
		    @of = File.new(scenefile, "w")

		    tbuff_arr.each{|line|
			    line.sub!("[MATERIALNAME]", '"' + cmatname + '"' )
			    if line[/\[MATERIAL_SETTING\]/]
			    	export_mtl_material()
				elsif line[/\[VOL_SETTING\]/]
					Sketchup.active_model.materials.each{|mat|
						export_volume( mat , @of )
					}
			    elsif line[/\[ENV_SETTING\]/]
			    	if cmatname[/EMIS/] == nil
						@of.puts "SkyLight 1.00000000 1.00000000 1.00000000 #{hdrname}"
					end
			    elsif line[/\[LIGHT_SETTING\]/]
			    	if cmatname[/EMIS/] == nil
						@of.puts "new ParallelLight"
						@of.puts "	Emission  1.0 1.0 1.0"
						@of.puts "	Direction -0.49821060 0.49977924 0.70852447"
					end
			    else
			    	@of.puts line
				end
			}


			@of.flush
			@of.close
			#bfile = material_batch_file( cmatname )
			#bfile.gsub!(/\\/,"\/")
			#UI.openURL bfile
			command_line = material_batch_code( cmatname)
			system(command_line)
		end
	end
	def material_batch_code( cmatname )
		return if cmatname == ""
		thisdir = File.dirname(File.expand_path(__FILE__))
		render_path = @render_path.gsub(/\//,'\\')

		scenefile = File.join( thisdir , "su2objmtl/mat_scene/mat_scene2.vdr" )
		scenefile.gsub!(/\//,'\\')
		
		outputfile = File.join( thisdir , "su2objmtl/" + cmatname + ".png" )
		outputfile.gsub!(/\//,'\\')


		batchcode = "start \"max\" \"#{render_path}\" "
		batchcode = batchcode + "\"#{scenefile}\" /width=200 /height=200 /run\""

		return batchcode
	end
	def material_batch_file( cmatname )
		return if cmatname == ""
		thisdir = File.dirname(File.expand_path(__FILE__))
		batchname = "mat_render.bat"
		#cmat = Sketchup.active_model.materials.current
		#cmatname =  enc_kconv(cmat.name)
		batchfile = File.join( thisdir ,"su2objmtl/mat_scene/" + batchname)
		driveletter = @render_path.split(":")[0] + ":"
		render_path = @render_path.gsub(/\//,'\\')
		renderengine = File.basename(@render_path, ".exe")
		scenefile = File.join( thisdir , "su2objmtl/mat_scene/mat_scene2.vdr" )
		scenefile.gsub!(/\//,'\\')
		outputfile = File.join( thisdir , "su2objmtl/" + cmatname + ".png" )
		outputfile.gsub!(/\//,'\\')

		of = File.new(batchfile, "w")
		of.puts driveletter
		of.puts "cd #{File.dirname(render_path)}"
		batchcode = renderengine 
		batchcode = batchcode + ' "' + scenefile + '"'
		batchcode = batchcode + ' /width=200 /height=200 /run'
		#batchcode = batchcode + ' /out="' + outputfile + '"'
		of.puts batchcode
		of.flush
		of.close
		return batchfile
	end

	def material_list_webdialog
		thisdir = File.dirname(File.expand_path(__FILE__))
		searchfiles = thisdir + "/su2objmtl/*.png"
		cr = "\n"
	    shtm = '<html lang="ja"><head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />'
	    shtm = shtm + "</head><body scroll=yes><basefont size='2'>" + cr
	    shtm = shtm + "<script type='text/javascript'>"+ cr
		shtm = shtm + "<!--"+ cr
	 	shtm = shtm + "function change_name( pngstr ) {"+ cr
		shtm = shtm + "  document.getElementById('rename_string').value=pngstr;"+cr
		shtm = shtm + "  window.location='skp:mat_rename';"+ cr
		shtm = shtm + "  scrollTo(0,0);"+cr
	 	shtm = shtm + "}"+ cr
	 	shtm = shtm + "function reload_me(obj) {"+ cr
		shtm = shtm + "  window.location='skp:reload_catalog';"+ cr
	 	shtm = shtm + "}"+ cr
		shtm = shtm + "--></script>" + cr
	    cnt = 0
		shtm = shtm + "<input type='text' name='rename_string' id='rename_string' value='' style='width:150'>"+cr
	    shtm = shtm + "<input type='button' name='Reload' value='Reload' onClick='reload_me(this)'><BR>"+cr
		Dir::glob( searchfiles ).each {|fpng|
			fulpng = File::expand_path(fpng)
			altpng = File::basename(fpng , '.*' )
	      	shtm = shtm + "<a href =\"JavaScript:change_name('" + altpng + "')\" >" + cr
	      	shtm = shtm + '<img src="' + fulpng + '" width="200" height="200" class="thumb" alt="' + altpng + '">' + cr
			shtm = shtm + "</a>" + cr + cr
			#shtm = shtm + "<BR>#{altpng}</a><BR>" + cr + cr
			cnt += 1
		}
	    shtm = shtm + "</body></html>"
		@mdlg = UI::WebDialog.new("Vidro Render Material setting", true, "Units Picker", 100, 100, 150, 150, true)
		@mdlg.set_html(shtm)

	    @mdlg.add_action_callback("mat_rename"){|d,p|
			#cmat = Sketchup.active_model.materials.current
			#cmatname = cmat.name
			#rename_string = @mdlg.get_element_value("rename_string")
			#cmat.name = cmatname + "_" + rename_string if rename_string != ""
  	    }
	    @mdlg.add_action_callback("reload_catalog"){|d,p|
			@mdlg.close
			material_list_webdialog
  	    }

		@mdlg.show
		@mdlg.set_size 250,550
		@mdlg.set_position 550,200
	end
############################################################################################
	def get_mat_param_from_dialog()
		localsetting_init
		@use_textures = true
		@render_setting_file = File.basename(__FILE__)
		#break if load_render_setting( @render_setting_file ) == false
		@scenefile = "default.vdr" if @scenefile == ""
		
		@objmode = @wdlg.get_element_value("export_mode")
		@use_sun = @wdlg.get_element_value("use_sun")
		@image_type = @wdlg.get_element_value("image_type")
		@image_size = @wdlg.get_element_value("image_size")
		@gi = @wdlg.get_element_value("gi")
	end
	def material_edit_show_webdialog
		#File.basename(__FILE__)
	    model = Sketchup.active_model
	    @mat_wdlg = UI::WebDialog.new("Vidro Material Editor", true, "Vidro Material Editor", 100, 100, 150, 150, true)
		htmfile = File.join( File.dirname( File.expand_path(__FILE__) ), "su2objmtl" , "su2objmtl_vidro_materialedit.html" )
		#Sketchup.find_support_file "su2objmtl_vidro_materialedit.html", "Plugins/su2objmtl/"
	    @mat_wdlg.set_file(htmfile)
		@mat_wdlg.add_action_callback("material_preview"){|d,p|
			make_material_thumb()
		}
		@mat_wdlg.add_action_callback("update_mat_list"){|d,p|
			material_list_update()
		}
	    @mat_wdlg.add_action_callback("change_mat_list"){|d,p|
			selected_mat = @mat_wdlg.get_element_value("material_list")
			model.materials.current = selected_mat
			load_material_param()
  	    }
	    @mat_wdlg.add_action_callback("save_mat_param"){|d,p|
			save_material_param()
  	    }
	    @mat_wdlg.add_action_callback("selectfile"){|d,p|
			open_filename = UI.openpanel"Select Mapfile", "", ""
			return if open_filename == nil
			open_filename.gsub!(/\\/,'/')
			cmd = "document.getElementById('#{p}').value='#{open_filename}';"
			@mat_wdlg.execute_script( cmd )
  	    }
		@mat_wdlg.add_action_callback("reload"){|d,p|
			material_list_update()
			mats = Sketchup.active_model.materials
			cmat = mats.current
			if cmat
				@mat_wdlg.execute_script("selectListbox('material_list','#{cmat.name}')" )
			end
			load_material_param()
		}
	    @mat_wdlg.show{
			material_list_update()
			mats = Sketchup.active_model.materials
			cmat = mats.current
			if cmat
				@mat_wdlg.execute_script("selectListbox('material_list','#{cmat.name}')" )
			end
			load_material_param()
		}
	end
	def material_list_update()
		mats = Sketchup.active_model.materials
		@mat_wdlg.execute_script( "document.getElementById('material_list').length =0;" )
		mats.each{|mat|
			@mat_wdlg.execute_script( "document.getElementById('material_list').options[document.getElementById('material_list').length] = new Option('#{mat.name}','#{mat.name}')" )
		}
	end
	def clear_matereial_param()
		@mat_wdlg.execute_script('set_text( "diffuse" , "1.0" )')
		@mat_wdlg.execute_script('set_text( "emis" , "" )')
		@mat_wdlg.execute_script('set_text( "refl" , "" )')
		@mat_wdlg.execute_script('set_text( "refl_ior" , "" )')
		@mat_wdlg.execute_script('set_text( "spec" , "" )')
		@mat_wdlg.execute_script('set_text( "spec_refl" , "" )')
		@mat_wdlg.execute_script('set_text( "axis_x" , "" )')
		@mat_wdlg.execute_script('set_text( "axis_y" , "" )')
		@mat_wdlg.execute_script('set_text( "axis_z" , "" )')
		@mat_wdlg.execute_script('set_text( "ior_front" , "" )')
		@mat_wdlg.execute_script('set_text( "ior_back" , "" )')
		@mat_wdlg.execute_script('set_text( "exp_u" , "" )')
		@mat_wdlg.execute_script('set_text( "exp_v" , "" )')
		@mat_wdlg.execute_script('set_text( "emis_map" , "" )')
		@mat_wdlg.execute_script('set_text( "emis_dstr" , "" )')
		@mat_wdlg.execute_script('set_text( "portal" , "" )')
		@mat_wdlg.execute_script('set_text( "refl_map" , "" )')
		@mat_wdlg.execute_script('set_text( "normal_map" , "" )')
		@mat_wdlg.execute_script('set_text( "spec_map" , "" )')
		@mat_wdlg.execute_script('set_text( "trans_map" , "" )')
		@mat_wdlg.execute_script('selectListbox("jump1","")')
		@mat_wdlg.execute_script('selectListbox("jump2","")')
		@mat_wdlg.execute_script('selectListbox("background","0")')
		@mat_wdlg.execute_script('set_text( "anisto" , "" )')
		@mat_wdlg.execute_script('set_text( "extinc" , "" )')
		@mat_wdlg.execute_script('set_text( "albedo" , "" )')
		@mat_wdlg.execute_script('set_text( "sky_file" , "" )')
		@mat_wdlg.execute_script('selectListbox("sky_rgb","0 0 0")')
		@mat_wdlg.execute_script('selectListbox("use_volume","no")')
	end
	def load_material_param()
		selected_mat = @mat_wdlg.get_element_value("material_list")
		cmat = Sketchup.active_model.materials[ selected_mat ]
		if cmat
			cmat_att = cmat.attribute_dictionaries["vidro_material_setting"]
			if cmat_att == nil
				cmat_att = material_props_by_name( cmat )
				#extract_material_param(props)
			end
			if cmat_att
				#props = cmat_att
				extract_material_param(cmat_att)
			end
		end
	end
	def extract_material_param(props)
		props.each{|key,val|
			if key.include?("@")
				@mat_wdlg.execute_script("selectListbox('#{key.sub(/\@/,'')}','#{val}')" )
			else
				@mat_wdlg.execute_script( "set_text('#{key}' , '#{val}');" )
				#@mat_wdlg.execute_script( "document.getElementById('#{key}').value = '#{val}';" )
			end
		}
	end
	def save_material_param()
		#props = "emis,refl,refl_ior,spec,spec_refl,axis_x,axis_y,axis_z".split(",")
		#props.push "ior_front,ior_back,exp_u,exp_v,emis_map,emis_dstr,portal".split(",")
		#props.push "refl_map,normal_map,spec_map,trans_map,volume_front,volume_back".split(",")
		#props.push "jump1,jump2,background".split(",")
		#props.flatten!
		props = Hash.new
		props["diffuse"] = @mat_wdlg.get_element_value("diffuse")
		props["emis"] = @mat_wdlg.get_element_value("emis")
		props["refl"] = @mat_wdlg.get_element_value("refl")
		props["refl_ior"] = @mat_wdlg.get_element_value("refl_ior")
		props["spec"] = @mat_wdlg.get_element_value("spec")
		props["spec_refl"] = @mat_wdlg.get_element_value("spec_refl")
		props["axis_x"] = @mat_wdlg.get_element_value("axis_x")
		props["axis_y"] = @mat_wdlg.get_element_value("axis_y")
		props["axis_z"] = @mat_wdlg.get_element_value("axis_z")
		props["ior_front"] = @mat_wdlg.get_element_value("ior_front")
		props["ior_back"] = @mat_wdlg.get_element_value("ior_back")
		props["exp_u"] = @mat_wdlg.get_element_value("exp_u")
		props["exp_v"] = @mat_wdlg.get_element_value("exp_v")
		props["emis_map"] = @mat_wdlg.get_element_value("emis_map")
		props["emis_dstr"] = @mat_wdlg.get_element_value("emis_dstr")
		props["portal"] = @mat_wdlg.get_element_value("portal")
		props["refl_map"] = @mat_wdlg.get_element_value("refl_map")
		props["normal_map"] = @mat_wdlg.get_element_value("normal_map")
		props["spec_map"] = @mat_wdlg.get_element_value("spec_map")
		props["trans_map"] = @mat_wdlg.get_element_value("trans_map")
		#props["volume_front"] = @mat_wdlg.get_element_value("volume_front")
		#props["volume_back"] = @mat_wdlg.get_element_value("volume_back")
		props["use_volume"] = @mat_wdlg.get_element_value("use_volume")
		props["@jump1"] = @mat_wdlg.get_element_value("jump1")
		props["@jump2"] = @mat_wdlg.get_element_value("jump2")
		props["@background"] = @mat_wdlg.get_element_value("background")
		
		props["anisto"] = @mat_wdlg.get_element_value("anisto")
		props["extinc"] = @mat_wdlg.get_element_value("extinc")
		props["albedo"] = @mat_wdlg.get_element_value("albedo")
		#props["hm_extinc"] = @mat_wdlg.get_element_value("hm_extinc")
		#props["hm_albedo"] = @mat_wdlg.get_element_value("hm_albedo")
		props["sky_file"] = @mat_wdlg.get_element_value("sky_file")
		props["@sky_rgb"] = @mat_wdlg.get_element_value("sky_rgb")

		selected_mat = @mat_wdlg.get_element_value("material_list")
		cmat = Sketchup.active_model.materials[ selected_mat ]
		if cmat
			props.each{|key,val|
				if val
					cmat.set_attribute( "vidro_material_setting", key, val )
				end
			}
		end
		Sketchup.set_status_text "Saved!"
	end
	def render_show_webdialog
		jap2englist()
		get_objmtl_ini( File.basename(__FILE__) )
	    model = Sketchup.active_model
	    @wdlg = UI::WebDialog.new("Vidro Render Exporter setting", true, "VidroExporterSetting", 100, 100, 150, 150, true)
		htmfile = File.join( File.dirname( File.expand_path(__FILE__) ), "su2objmtl" , "su2objmtl_vidro_man.html" )
		#Sketchup.find_support_file "su2objmtl_vidro_man.html", "Plugins/su2objmtl/"
	    @wdlg.set_file(htmfile)
		@wdlg.add_action_callback("clearparam"){|d,p|
			clear_matereial_param()
		}
	    @wdlg.add_action_callback("loadparam"){|d,p|
			load_parameta()
  	    }
	    @wdlg.add_action_callback("saveparam"){|d,p|
			save_parameta()
  	    }
	    @wdlg.add_action_callback("selectibl"){|d,p|
			open_filename = UI.openpanel"Select IBLfile", "", ""
			return if open_filename == nil
			open_filename.gsub!(/\\/,'/')
			@wdlg.execute_script("document.getElementById('ibl_file').value='#{open_filename}';")
  	    }
	    @wdlg.add_action_callback("selectrender"){|d,p|
			@render_path = @wdlg.get_element_value("render_engin")
			@wdlg.execute_script("document.getElementById('render_engin').value='#{@render_path}';") if find_render
			save_objmtl_ini( File.basename(__FILE__) )
  	    }
	    @wdlg.add_action_callback("start_objmtl"){|d,p|

			get_parameta_from_dialog()
		
			##@use_textures = @wdlg.get_element_value("use_texture")
			#@autorender = @wdlg.get_element_value("auto_render")
			@autorender = "start_render"
			#getval = @wdlg.get_element_value("openimage")
			@openimage = "no"
			
			#save_parameta()
			
			return if render_check == false
			startexport()
	    }
	    @wdlg.show{
			@wdlg.execute_script("document.getElementById('render_engin').value='#{@render_path.gsub(/\\/,'/')}'" )
		}
		#@wdlg.set_size 250,550
		#@wdlg.set_position 550,200
	end
	def localsetting_init
	    	@objmfile	= ""#ジオメトリファイル　空欄のときはsceneファイルに追記
	    	@mtlfile	= ""#材質ファイル　空欄のときはsceneファイルに追記
	    	@objmode = "all_models_and_vie"
	    	#@auto = "yes"
	    	@use_textures = true
	    	@use_sun = "yes"
	    	@image_type = "png"
	    	@image_size = "480x270"
	    	@gi = "1024"
	    	@alsample = "256"
	    	@plsample = "256"
	    	@fr = ""
	    	@osbase = "16"
	    	@oversample = "16"
	    	@smooth = "yes"
	    	@clay = "no"
	    	@defcolor = "0.9 0.9 0.9"
	    	@fps = "24"
	    	@pers2p = "no"
	    	@cphoton = "1048576"
	    	@vphoton = "1048576"
	    	ibl_rgb = "0 0 0"
	    	ibl_file = ""
	     	#@render_setting_file = ""
			@autorender = "start_render"
			#@aspect = "1.33"
			@openimage = "no"
			@ae = "yes"
			@claymat = "default_mat"
			@enemi = "0"
			@camlight = "0"
			@eyedist = "40"
			@ibl_rgb = "100 100 100"
			@ibl_file = ""
			@exscene = "this"
			#@render_path = ""
			@vdrscale = (1.0).to_f
	end
	def setting_init
		@vdrscale = (1.0).to_f
		@scenefile = 'default.vdr'
		@geomfile = 'vidro_geom.txt'
		@scene_dir = 'su_render'
		@batchcode = 'su_render\[scenefile] /width=[image_w] /height=[image_h]'
		@obj_onefile = 'no'
		@textures_prefix = 'tx_default'
		@of = nil
		@wsec = false
	end
	def get_parameta_from_dialog()
		localsetting_init
		@use_textures = true
		@render_setting_file = File.basename(__FILE__)
		#break if load_render_setting( @render_setting_file ) == false
		@scenefile = "default.vdr" if @scenefile == ""
		
		@objmode = @wdlg.get_element_value("export_mode")
		@use_sun = @wdlg.get_element_value("use_sun")
		@image_type = @wdlg.get_element_value("image_type")
		@image_size = @wdlg.get_element_value("image_size")
		@gi = @wdlg.get_element_value("gi")
		@alsample = @wdlg.get_element_value("alsample")
		@plsample = @wdlg.get_element_value("plsample")
		@cphoton = @wdlg.get_element_value("cphoton")
		@vphoton = @wdlg.get_element_value("vphoton")
		@osbase = @wdlg.get_element_value("os")
		@fr = @wdlg.get_element_value("fr")
		@disto = @wdlg.get_element_value("disto")
		@pers2p = @wdlg.get_element_value("pers2p")
		@ae = @wdlg.get_element_value("ae")
		@defcolor = @wdlg.get_element_value("defcol")
		@clay = @wdlg.get_element_value("clay")
		@enemi = @wdlg.get_element_value("enemi")
		@camlight = @wdlg.get_element_value("camlight")
		@eyedist = @wdlg.get_element_value("eyedist")
		@ibl_rgb = @wdlg.get_element_value("ibl_rgb")
		@ibl_file = @wdlg.get_element_value("ibl_file")
		@fps = @wdlg.get_element_value("fps")
		@exscene = @wdlg.get_element_value("exscene")
		@render_path = @wdlg.get_element_value("render_engin")
		@render_path.gsub!(/\//,'\\')
		#@aspect = @image_size.split('x')[0].to_f / @image_size.split('x')[1].to_f
		#@oversample = @wdlg.get_element_value("os")

	end
	def save_parameta()
		get_parameta_from_dialog()
		model=Sketchup.active_model
		ad = model.attribute_dictionary("su2objmtl_vidro_setting",true)
		##ad["@objmode"] = @objmode #"export_mode"
		##ad["@use_textures"] = @use_textures#boolean "use_texture"--yes_no
		ad["@use_sun"] = @use_sun if @use_sun
		ad["@image_type"] = @image_type if @image_type
		ad["@image_size"] = @image_size if @image_size
		ad["@gi"] = @gi if @gi
		ad["@alsample"] = @alsample if @alsample
		ad["@plsample"] = @plsample if @plsample
		ad["@cphoton"] = @cphoton if @cphoton
		ad["@vphoton"] = @vphoton if @vphoton
		ad["@osbase"] = @osbase if @osbase
		ad["@fr"] = @fr if @fr
		ad["@disto"] = @disto if @disto
		ad["@pers2p"] = @pers2p if @pers2p
		##ad["@openimage"] = @openimage#boolean --open-or not
		ad["@ae"] = @ae if @ae
		ad["@defcolor"] = @defcolor if @defcolor
		ad["@clay"] = @clay if @clay
		ad["@enemi"] = @enemi if @enemi
		ad["@camlight"] = @camlight if @camlight
		ad["@eyedist"] = @eyedist if @eyedist
		ad["@ibl_rgb"] = @ibl_rgb if @ibl_rgb
		ad["@ibl_file"] = @ibl_file if @ibl_file
		##ad["@exscene"] = @exscene
		ad["@fps"] = @fps if @fps
		##ad["@render_path"] = @render_path
	end
	def load_parameta()
		model=Sketchup.active_model
		ad = model.attribute_dictionary("su2objmtl_vidro_setting",true)
		@use_sun = ad["@use_sun"] if ad["@use_sun"]
		@image_type = ad["@image_type"] if ad["@image_type"]
		@image_size = ad["@image_size"] if ad["@image_size"]
		@gi = ad["@gi"] if ad["@gi"]
		@alsample = ad["@alsample"] if ad["@alsample"]
		@plsample = ad["@plsample"] if ad["@plsample"]
		@cphoton = ad["@cphoton"] if ad["@cphoton"]
		@vphoton = ad["@vphoton"] if ad["@vphoton"]
		@osbase = ad["@osbase"] if ad["@osbase"]
		@fr = ad["@fr"] if ad["@fr"]
		@disto = ad["@disto"] if ad["@disto"]
		@pers2p = ad["@pers2p"] if ad["@pers2p"]
		@ae = ad["@ae"] if ad["@ae"]
		@defcolor = ad["@defcolor"] if ad["@defcolor"]
		@clay = ad["@clay"] if ad["@clay"]
		@enemi = ad["@enemi"] if ad["@enemi"]
		@camlight = ad["@camlight"] if ad["@camlight"]
		@eyedist = ad["@eyedist"] if ad["@eyedist"]
		@ibl_rgb = ad["@ibl_rgb"] if ad["@ibl_rgb"]
		@ibl_file = ad["@ibl_file"] if ad["@ibl_file"]
		@fps = ad["@fps"] if ad["@fps"]
		extract_to_dialog()
	end
	def extract_to_dialog()
		@wdlg.execute_script("document.getElementById('ibl_file').value='#{@ibl_file.gsub(/\\/,'/')}'" )
		@wdlg.execute_script("selectListbox('use_sun','#{@use_sun}')" )
		@wdlg.execute_script("selectListbox('image_type','#{@image_type}')" )
		@wdlg.execute_script("selectListbox('image_size','#{@image_size}')" )
		@wdlg.execute_script("selectListbox('gi','#{@gi}')" )
		@wdlg.execute_script("selectListbox('alsample','#{@alsample}')" )
		@wdlg.execute_script("selectListbox('plsample','#{@plsample}')" )
		@wdlg.execute_script("selectListbox('cphoton','#{@cphoton}')" )
		@wdlg.execute_script("selectListbox('vphoton','#{@vphoton}')" )
		@wdlg.execute_script("selectListbox('os','#{@osbase}')" )
		@wdlg.execute_script("selectListbox('fr','#{@fr}')" )
		@wdlg.execute_script("selectListbox('disto','#{@disto}')" )
		@wdlg.execute_script("selectListbox('pers2p','#{@pers2p}')" )
		@wdlg.execute_script("selectListbox('ae','#{@ae}')" )
		@wdlg.execute_script("selectListbox('defcol','#{@defcolor}')" )
		@wdlg.execute_script("selectListbox('clay','#{@clay}')" )
		@wdlg.execute_script("selectListbox('enemi','#{@enemi}')" )
		@wdlg.execute_script("selectListbox('camlight','#{@camlight}')" )
		@wdlg.execute_script("selectListbox('eyedist','#{@eyedist}')" )
		@wdlg.execute_script("selectListbox('ibl_rgb','#{@ibl_rgb}')" )
		@wdlg.execute_script("selectListbox('fps','#{@fps}')" )
	end
############################################################################################
	def startexport()
		save_objmtl_ini( File.basename(__FILE__) )
		all_init
		export
	end
	def create_batch_code()#,image_type = "png",image_size="320x180",gi = 256,oversample = 8,openimage = true)
		#driveletter = @render_path.split(":")[0] + ":"
		render_path = @render_path.gsub(/\//,'\\')
		#@batchcode = 'su_render\[scenefile] /width=[image_w] /height=[image_h]'
		commandline = "start \"max\" \"#{render_path}\" \"#{@scenefile.gsub(/\//,"\\")}\""
		batchcode = ""
		#scenefile = File.basename( @scenefile.gsub(/\//,"\\"),".*") + ".vdr"
		#batchcode = @batchcode.sub( "[scenefile]","#{scenefile}" )
		batchcode = batchcode + " /width=#{@image_size.split(/x/)[0]}"
		batchcode = batchcode + " /height=#{@image_size.split(/x/)[1]}"
		batchcode = batchcode + " /run"# if @autorender == "start_render"
		batchcode = batchcode + " /gi=" + @gi.to_s
		batchcode = batchcode + " /oversampling=" + @osbase.to_s
		batchcode = batchcode + " /arealight=" + @alsample.to_s
		batchcode = batchcode + " /pointlight=" + @plsample.to_s
		batchcode = batchcode + " /cp=" + @cphoton.to_s
		batchcode = batchcode + " /vp=" + @vphoton.to_s
		batchcode = batchcode + " /ae=false" if @ae == "no"

		commandline = commandline + batchcode
		return commandline
	end
	def create_batch_file()#,image_type = "png",image_size="320x180",gi = 256,oversample = 8,openimage = true)
		batchname = "render_batch.bat"
		batchfile = File.join(File.dirname(@render_path),batchname)
		driveletter = @render_path.split(":")[0] + ":"
		render_path = @render_path.gsub(/\//,'\\')
		of = File.new(batchfile, "w")
		of.puts driveletter
		of.puts "cd #{File.dirname(render_path)}"
		if @vdrlist.length != 0
			@vdrlist.each{|vdrname|
				scenefile = vdrname.gsub(/\//,"\\")
				outputfile =File.join(File.dirname(@render_path),File.basename(vdrname,".*"))+ ".png"
				Sketchup.set_status_text "write to batch file #{vdrname}"
				#outputfile =File.basename(vdrname,".*") + ".png"
				outputfile.gsub!(/\//,"\\")
				batchexe = get_batchcode( scenefile , outputfile )
				of.puts batchexe
			}
		else
			scenefile = File.basename( @scenefile.gsub(/\//,"\\"),".*") + ".vdr"
			outputfile = ""
			if @openimage == "yes" and ( @image_type == "png" or @image_type == "jpg" or @image_type == "bmp" or @image_type == "tif" )
				outputfile =File.join(File.dirname(@render_path),(@title + "." + @image_type) )
				outputfile.gsub!(/\//,"\\")
			end
			batchexe = get_batchcode( scenefile , outputfile )
			of.puts batchexe
		end
		of.flush
		of.close
		return batchfile
	end
	def get_batchcode( scenefile , outputfile = "" )
		#batchcode = @batchcode.sub( "[scenefile]","#{scenefile}" )
		#batchcode = batchcode.sub( "[image_w]" , (@image_size.split(/x/)[0]).to_s)
		#batchcode = batchcode.sub( "[image_h]" , (@image_size.split(/x/)[1]).to_s)
		batchcode = "su_render/#{scenefile}"
		batchcode = batchcode + " /width=#{@image_size.split(/x/)[0]}"
		batchcode = batchcode + " /height=#{@image_size.split(/x/)[1]}"
		batchcode = batchcode + " /run"# if @autorender == "start_render"
		batchcode = batchcode + " /gi=" + @gi.to_s
		batchcode = batchcode + " /oversampling=" + @osbase.to_s
		batchcode = batchcode + " /arealight=" + @alsample.to_s
		batchcode = batchcode + " /pointlight=" + @plsample.to_s
		batchcode = batchcode + " /cp=" + @cphoton.to_s
		batchcode = batchcode + " /vp=" + @vphoton.to_s
		batchcode = batchcode + " /ae=false" if @ae == "no"
		if outputfile != ""
			batchcode = batchcode + " /out=\"#{outputfile}\""
		end
		renderengine = File.basename(@render_path, ".exe")
		batchexe = "#{renderengine} " + %(#{batchcode})
		return batchexe
	end

	def export_geom_file()
		#@geomfile
		#export vdr object
		gmf = File.new(@geomfile, "w")
		output_light_code = []
		@store_pointlight.each{|plight|
			pppos =plight[0]
			pobj =plight[1]
			ppvec =plight[2]
			emis =plight[3].to_f
			sprad = plight[4]
			spfal = plight[5]
			ppos = pppos
			pvec = ppvec

			spotimage = ""
			clr = plight[6]
			if sprad !=0
				spotimage = make_spotmap(sprad ,spfal)
				spotimage = @textures_prefix + "\\" + spotimage if spotimage != nil and spotimage != ""
			end
			#if pobj == ""
			@obj_list.find_all{|ol| ol[0] == pobj }.each{|ol2|
				o = ol2[1]
				ppos = o * pppos if o != nil
				pvec = o * ppvec if o != nil
				output_light_code.push "new PointLight"
				if spotimage != ""
					output_light_code.push "	Intensity #{emis * clr.red / 255} #{emis * clr.green / 255} #{emis * clr.blue / 255} \"#{spotimage}\""
				else
					output_light_code.push "	Intensity #{emis * clr.red / 255} #{emis * clr.green / 255} #{emis * clr.blue / 255}"
				end
				output_light_code.push "	Position  #{PRECISION % ( ppos.x.to_m.to_f * @vdrscale.to_f * @vdrscale.to_f ) } #{PRECISION % ( ppos.z.to_m.to_f * @vdrscale.to_f * @vdrscale.to_f )} #{PRECISION % (-ppos.y.to_m.to_f * @vdrscale.to_f * @vdrscale.to_f )}"
				if pvec.samedirection? Geom::Vector3d.new( 0,0,-1 )#法線が下向きの時
				elsif pvec.samedirection? Geom::Vector3d.new( 0,0,1 )#法線が上向きの時
					output_light_code.push "	X  1 0 0"
					output_light_code.push "	Y  0 -1 0"
					output_light_code.push "	Z  0 0 1"
				else#法線が傾いているとき
					zvec = Geom::Vector3d.new 0,0,1
					rad = zvec.angle_between(pvec)
					nnvec = zvec.cross(pvec)
					if nnvec != nil
						t = Geom::Transformation.rotation ppos, nnvec, rad
						xvec = t * Geom::Vector3d.new(-1,0,0)
						yvec = t * Geom::Vector3d.new(0,0,-1)
						zvec = t * Geom::Vector3d.new(0,1,0)
						output_light_code.push "	X  #{PRECISION % xvec.x.to_f} #{PRECISION % xvec.z.to_f} #{PRECISION % (-xvec.y.to_f)}"
						output_light_code.push "	Y  #{PRECISION % yvec.x.to_f} #{PRECISION % yvec.z.to_f} #{PRECISION % (-yvec.y.to_f)}"
						output_light_code.push "	Z  #{PRECISION % zvec.x.to_f} #{PRECISION % zvec.z.to_f} #{PRECISION % (-zvec.y.to_f)}"
					end
				end
			}
			#end
		}

		output_light_code.each{|e| gmf.puts e }

		@obj_list.each{|ol|
			obj = ol[0]
			o = ol[1]
			m = enc_kconv(ol[2])
			gmf.puts "new Object"
			gmf.puts "	File \"#{obj}.obj\""
			if o == nil
				gmf.puts "	Position 0.0 0.0 0.0"
				gmf.puts "	Material \"#{m}\""
				gmf.puts "	X #{ @vdrscale.to_f } 0.0 0.0"
				gmf.puts "	Y 0.0 #{ @vdrscale.to_f } 0.0"
				gmf.puts "	Z 0.0 0.0 #{ @vdrscale.to_f }"
			else
				gmf.puts "	Position #{PRECISION % ( o.origin.x.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % ( o.origin.z.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (-o.origin.y.to_m.to_f * @vdrscale.to_f )}"
				gmf.puts "	Material \"#{m}\""
				#axis = o.xaxis
				axis = o * (Geom::Vector3d.new 1,0,0)
				gmf.puts "	X #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
				#axis = o.zaxis
				axis = o * (Geom::Vector3d.new 0,0,1)
				gmf.puts "	Y #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
				#axis = o.yaxis
				axis = o * (Geom::Vector3d.new 0,-1,0)
				gmf.puts "	Z #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
			end
		}
		gmf.flush
		gmf.close
	end

	def export()#(objmode = true,auto = true,use_textures = true,use_sun = true,image_type = "jpg",image_size="320x180",gi = 256,oversample = 8,openimage = true,ibl = "")
		pages = Sketchup.active_model.pages
		#次のケースはページが足りないときはエラーするので前もって、止める。
		return if @exscene == "all" and pages.count == 0
		return if @exscene == "anime" and pages.count < 2
		return if @exscene == "3DAnime" and pages.count < 2
		
		buffer_init if @objmode == "all_models_and_view"
		starttime = Time.now.to_f
	    @title = Sketchup.active_model.title
	    @title = "Untitled" if @title.length == 0
		@title = enc_kconv(@title)
		@export_dir = File.dirname(@render_path) + "\\" + @scene_dir
	    if FileTest.exist? (@export_dir)
	    else
	        Dir.mkdir(@export_dir)
	    end

		@useportal = false
		@ibl_file.gsub!('/','\\')
		@objfile = File.join(@export_dir,(File.basename(@scenefile,".*") + ".obj")) if @objfile == nil or @objfile == ""
		@mtllib = File.basename(@scenefile,".*") + ".mtl"
		@mtlfile =  File.join(@export_dir,(@mtllib))
		@store_pointlight = []
		@geomfile = File.join(@export_dir,(@geomfile))
		@s2v_used_material = []
		Sketchup.active_model.materials.each{|mat| @s2v_used_material.push mat }
		#if File.exists?( @geomfile )
		Sketchup.set_status_text "export OBJ_file"
		
		if @objmode == "all_models_and_view" or File.exists?( @geomfile ) == false
			export_obj()
		end
		@of.close if @of != nil
		@of = nil if @of != nil
		
		if @objmode == "all_models_and_view" or File.exists?( @geomfile ) == false
			export_geom_file()
		end

		export_textures

		@vdrlist = []
		sp = nil
		@sp = nil
		
		sel = Sketchup.active_model.selection
		if (sel[0])
			if sel[0].typename == "SectionPlane"#選択オブジェクトが断面プレーンのとき
			sp = sel[0]
			end
		end
		seclist = Sketchup.active_model.entities.find_all{|ent| ent.kind_of? Sketchup::SectionPlane }
		sechash = Hash.new
		seclist.each{|secp|
			att = secp.get_attribute "su2objmtl", "onPage"
			sechash[att] = secp.get_plane if att != nil
		}
		
		if @exscene == "this"
			@scenefile = "default.vdr"
			@scenefile = enc_kconv(@scenefile)
			@scenefile =  File.join(@export_dir,(@scenefile))
			@camera = Sketchup.active_model.active_view.camera
			@sp = sp.get_plane if sp != nil
			Sketchup.set_status_text "creat Scene_file"
			export_render_scene()
		elsif @exscene == "all"
			pgcount = 0
			pages.each{|page|
				pages.selected_page = page
				@camera = page.camera
				if sechash[page.name.to_s] != nil
					@sp = sechash[page.name]
				else
					@sp = sp.get_plane if sp != nil
				end# if
				@scenefile = "default_" +( "0" * (4-pgcount.to_s.split(//).size) ) + pgcount.to_s + "_" + enc_kconv(page.name) + ".vdr"
				@vdrlist.push @scenefile
				Sketchup.set_status_text "creat Scene_file:#{@scenefile}"
				@scenefile =  File.join(@export_dir,(@scenefile))
				export_render_scene()
				pgcount += 1
			}
		elsif @exscene == "anime"
			sp_list = Hash.new
			#断面を保持するために一時取り込む
			Sketchup.active_model.entities.find_all{|tsp| tsp.typename == "SectionPlane" }.each{|tsp|
				sp_list[tsp] = tsp.get_plane
			}
			
			maxframe = pages.slideshow_time * @fps.to_i
			
			pages.show_frame_at ( 0.to_f / @fps.to_f )
			pagename_zero = pages.selected_page.name.to_s
			pages.show_frame_at ( 1.to_f / @fps.to_f )
			pagename_one = pages.selected_page.name.to_s
			
			cpagename0 = pagename_zero
			cpagename = pagename_one
			cframe = 0
			nplist = Hash.new
			nplist[cpagename0] = cpagename#0フレームのページ名とその次のページ名を取得
			#次のページの名前とそのフレーム数を算定してリストにする
			(1..( maxframe + 1)).each{|frame|
				ccfr = frame
				ccfr = frame - maxframe -1 if frame > maxframe
				pages.show_frame_at ( ccfr / @fps.to_f )
				npagename = pages.selected_page.name.to_s
				if cpagename != npagename
					nplist[cpagename0] = [ cpagename , frame.to_i - 1 , cframe.to_i ]
					cframe = frame.to_i
					cpagename0 = cpagename
					cpagename = npagename
				end
			}
			cpagename0 = pagename_zero
			cpagename = pagename_one
			(1..(maxframe +1)).each{|frame|
					ccfr = frame
					ccfr = frame - maxframe -1 if frame > maxframe
					pages.show_frame_at ( ccfr / @fps.to_f )
					npagename0 = pages.selected_page.name.to_s
					if cpagename != npagename0#現時点で表示されるページ名が変化したとき、（ページを繰り上げる）
						#UI.messagebox cpagename + npagename0
						cpagenamepp = cpagename0
						cpagename0 = cpagename
						cpagename = npagename0
					end
					if sechash[cpagename0] != nil
						sech1 = sechash[cpagename0]
					elsif cpagenamepp != nil
						sech1 = sechash[cpagenamepp]
						sechash[cpagename0] = sechash[cpagenamepp]
					else
						sech1 = nil
					end
					if nplist[cpagename0] != nil
						npagename = nplist[cpagename0][0]
						nextframe = nplist[cpagename0][1]
						prevframe = nplist[cpagename0][2]
						if sechash[npagename] != nil
							sech2 = sechash[npagename]
						elsif sechash[cpagename0] != nil
							sech2 = sechash[cpagename0]
							sechash[npagename] = sechash[cpagename0]
							#その直前で使用した断面を引き継ぐ
						else
							sech2 = nil
						end
					end

					@sp = nil
					if sech1 != nil
						if sech2 != nil
							@sp = calc_sec_modify sech1, sech2, frame , nextframe , prevframe
						else
							@sp = sech1
						end
					else
						@sp = sp.get_plane if sp != nil
					end
					pages.show_frame_at ( (frame - 1).to_f / @fps.to_f )
					@camera = Sketchup.active_model.active_view.camera
					@scenefile = "default_anime_" +( "0" * ( 6 - frame.to_s.split(//).size) ) + frame.to_s + ".vdr"
					@vdrlist.push @scenefile
					Sketchup.set_status_text "creat Scene_file:#{@scenefile}"

					@scenefile =  File.join(@export_dir,(@scenefile))
					export_render_scene()
			}
			sp_list.each{|key,val|
				key.set_plane val
			}
		elsif @exscene == "3D"
			@sp = sp.get_plane if sp != nil
			camera = Sketchup.active_model.active_view.camera
			up = Geom::Vector3d.new( 0,0,1)
			cdir = camera.direction
			v = cdir.cross up
			v.length = @eyedist.to_i.mm
			eye = camera.eye + v
			target = camera.target

			@scenefile = "PURU3D_01.vdr"
			@vdrlist.push @scenefile
			@scenefile =  File.join(@export_dir,(@scenefile))
			@camera = Sketchup::Camera.new eye, target , up
			@camera.focal_length = camera.focal_length
			export_render_scene()

			eye = camera.eye
			@scenefile = "PURU3D_02.vdr"
			@vdrlist.push @scenefile
			@scenefile =  File.join(@export_dir,(@scenefile))
			@camera = Sketchup::Camera.new eye, target , up
			@camera.focal_length = camera.focal_length
			export_render_scene()

			@scenefile = "PURU3D_03.vdr"
			@vdrlist.push @scenefile
			@scenefile =  File.join(@export_dir,(@scenefile))
			eye = camera.eye + v.reverse
			@camera = Sketchup::Camera.new eye, target , up
			@camera.focal_length = camera.focal_length
			export_render_scene()
		elsif @exscene == "3DAnime"
			pages = Sketchup.active_model.pages
			sp_list = Hash.new
			Sketchup.active_model.entities.find_all{|tsp| tsp.typename == "SectionPlane" }.each{|tsp|
				sp_list[tsp] = tsp.get_plane
			}
			maxframe = ( pages.slideshow_time * @fps.to_f ).to_i
			#up = Geom::Vector3d.new( 0,0,1)
			camera = Sketchup.active_model.active_view.camera
			ceye = camera.eye
			ctar = camera.target
			baseTardir = Geom::Vector3d.new( ctar.x - ceye.x , ctar.y - ceye.y , ctar.z - ceye.z )
			tardist = baseTardir.length
			(0..maxframe).each{|frame|
				#UI.messagebox (frame.to_f / @fps.to_f).to_s
				pages.show_frame_at ( frame.to_f / @fps.to_f )
				camera = Sketchup.active_model.active_view.camera
				ceye = camera.eye
				ctar = camera.target
				cper = camera.perspective?
				cfov = camera.fov
				cdir = Geom::Vector3d.new( ctar.x - ceye.x , ctar.y - ceye.y , ctar.z - ceye.z )
				up1 = Geom::Vector3d.new( 0,0,1 )
				v = cdir.cross up1
				v.length = @eyedist.to_i.mm
				if ( frame % 2 ) == 0
					eye1 = Geom::Point3d.new( ceye.x + v.x , ceye.y + v.y , ceye.z + v.z )
				else
					eye1 = Geom::Point3d.new( ceye.x - v.x , ceye.y - v.y , ceye.z - v.z )
				end
				cdir.length = tardist
				tar1 = Geom::Point3d.new( ( ceye.x + cdir.x ) , ( ceye.y + cdir.y ) , ( ceye.z + cdir.z ) )
				#UI.messagebox "#{eye1}#{ctar}#{up1}#{cper}#{cfov}"
				@camera = Sketchup::Camera.new( eye1, tar1 , up1 , cper , cfov )
				#@camera.focal_length = flength
				#@camera = Sketchup.active_model.active_view.camera
				@sp = sp.get_plane if sp != nil
				@scenefile = "default_anime_" +( "0" * ( 6 - frame.to_s.split(//).size) ) + frame.to_s + ".vdr"
				@vdrlist.push @scenefile
				Sketchup.set_status_text "creat Scene_file:#{@scenefile}"
				@scenefile =  File.join(@export_dir,(@scenefile))
				export_render_scene()
				
			}
			sp_list.each{|key,val|
				key.set_plane val
			}
		end
		Sketchup.set_status_text "creat batch_file"
		bfile = create_batch_file()#,image_type,image_size,gi,oversample,openimage)
		bfile.gsub!(/\\/,"\/")

		wastetime = Time.now.to_f - starttime
		Sketchup.set_status_text "OBJ&MTL export finished! time is #{wastetime} sec"
		
		#UI.openURL bfile if @autorender == "start_render" and ( @exscene == "this" or @exscene == "3D" )
		if @vdrlist.length > 1
			UI.openURL bfile if @autorender == "start_render" and ( @exscene == "this" or @exscene == "3D" )
		else
			command_line = create_batch_code
			#if (ENV['OS'] =~ /windows/i)
				system(command_line)
			#end
		end
	end
	def export_render_scene()# ,usesun = true,ibl = "" )
	#p_aspect = @camera.aspect_ratio
	#@camera.aspect_ratio = 0.0
	#p_flength = @camera.focal_length
	#@camera.focal_length = p_flength * p_aspect if p_aspect != 0.0
	#  @export_dir　共用エクスポート用ディレクトリ
	#  @scenefile:scene file 		共用シーンファイル名
	#  @objfile  :object file 		共用オブジェクトファイル名
	#  @mtlfile  :material file 	共用マテリアルライブラリファイル名
	#  PRECISION ：precision		共用数値フォーマット（小数点桁）
	#  SCALE_FACTOR:scale factor	共用スケール（インチをメートル）
	
	#断面の設定
	#sel = Sketchup.active_model.selection
	#if (sel[0])
	#	if sel[0].typename == "SectionPlane"#選択オブジェクトが断面プレーンのとき
	if @sp != nil
			#sp = sel[0].get_plane#planは最初の3つが法線の方向で、最後の数値が原点からの距離となる
			sp = @sp
			bb = Sketchup.active_model.bounds
			cpt =  Geom::Point3d.new( (bb.max.x + bb.min.x)/2 ,(bb.max.y + bb.min.y)/2 ,(bb.max.z + bb.min.z)/2 )#領域の中心
			bbr = ( bb.min.distance bb.max ) / 50.8#領域の対角の距離
			svec = Geom::Vector3d.new(sp[0],sp[1],sp[2])
			cline = [cpt, svec ]#中心から断面に垂直な線
			cpt2 = Geom.intersect_line_plane(cline, sp)#中心線と断面の交点
			if svec == Geom::Vector3d.new(0,0,-1)
				svec_N = Geom::Vector3d.new 1,0,0#svecに直交するベクトル
				rad = 0.radians
				sec_t = Geom::Transformation.new
			elsif svec == Geom::Vector3d.new(0,0,1)
				svec_N = Geom::Vector3d.new 1,0,0#svecに直交するベクトル
				rad = 180.radians
				sec_t = Geom::Transformation.rotation Geom::Point3d.new(0,0,0), svec_N, rad
			else#法線がZ軸に対して傾いているとき
				svec_Z = Geom::Vector3d.new 0,0,-1 #svecに交差するベクトル
				rad = svec_Z.angle_between(svec)#svecとの角度
				svec_N = svec.cross(svec_Z)#svecに直交するベクトル
				sec_t = Geom::Transformation.rotation Geom::Point3d.new(0,0,0), svec_N, -rad
			end
			cpt2vec = Geom::Vector3d.new( cpt2.x ,cpt2.y ,cpt2.z )
			svec_N.length = bbr * 50.8 * 4.0
			cam_t = Geom::Transformation.translation( svec_N )
			#視点から断面への垂線と断面方向ベクトルが同方向の場合はカメラ移動。そうでない場合はカメラそのまま。
			line_c2sp = [@camera.eye,svec]
			pt_c2sp = Geom.intersect_line_plane( line_c2sp , sp )
			vec_c2sp = Geom::Vector3d.new( pt_c2sp.x - @camera.eye.x , pt_c2sp.y - @camera.eye.y , pt_c2sp.z - @camera.eye.z )
			vec_sp2sp = vec_c2sp.normalize + svec.normalize
			cam_t = nil if vec_sp2sp == Geom::Vector3d.new( 0 , 0 , 0 )
	end
	#	end
	#end
	if sec_t != nil
		if @wsec == false
			secfile = File.join(@export_dir,("su2objmtlsec.obj"))
			sof = File.new(secfile, "w")
			sof.puts "mtllib #{@mtllib}"
			sof.puts "v -#{bbr} 0 #{bbr}" #x,z,-y
			sof.puts "v -#{bbr} 0 -#{bbr}" #x,z,-y
			sof.puts "v #{bbr} 0 -#{bbr}" #x,z,-y
			sof.puts "v #{bbr} 0 #{bbr}" #x,z,-y
			sof.puts "vt 0 0" #x,z,-y
			sof.puts "vt 0 1" #x,z,-y
			sof.puts "vt 1 1" #x,z,-y
			sof.puts "vt 1 0" #x,z,-y
			sof.puts "vn 0 -1 0" #x,z,-y
			sof.puts "vn 0 -1 0" #x,z,-y
			sof.puts "vn 0 -1 0" #x,z,-y
			sof.puts "vn 0 -1 0" #x,z,-y
			sof.puts "f 1/1/1 2/2/1 3/3/1" #x,z,-y
			sof.puts "f 3/3/1 4/4/1 1//1" #x,z,-y
			sof.flush
			sof.close
			@wsec = true
		end
	end

	Sketchup.set_status_text "creat scene_file"
    @of = File.new(@scenefile, "w")
	@of.puts "vidro100630"
	export_mtl_material()

	if @useportal == false
		if @ibl_rgb[/(\d*) (\d*) (\d*)/]
	    	if FileTest.exist? (@ibl_file)
	    	else
	    		@ibl_file = ""
			end
			if @use_sun == "real"
		    	@ibl = "SkyLight #{PRECISION % ($1.to_f/100)**2.2 * 1.5 } #{PRECISION % ($2.to_f/100)**2.2 * 1.5 } #{PRECISION % ($3.to_f/100)**2.2 * 1.5 } \"#{@ibl_file}\""
			else
				#Environment
		    	@ibl = "SkyLight #{PRECISION % ($1.to_f/100)**2.2 } #{PRECISION % ($2.to_f/100)**2.2 } #{PRECISION % ($3.to_f/100)**2.2 } \"#{@ibl_file}\""
		    end
		end
	end

	@of.puts "new Space \"0\""
	@of.puts 'new Volume "vol"'
	#@of.puts 'new Volume "vol2"'
	@of.puts @ibl if @ibl != ""
	#export camera
	#camera = Sketchup.active_model.active_view.camera
    #091101変更箇所to_mをto_mmへ
    #２点透視モードを付けた。
	@of.puts "new Eye"
	if cam_t != nil
		eye = @camera.eye + svec_N
		tar = @camera.target + svec_N
	else
		eye = @camera.eye
		tar = @camera.target
	end
	cup = @camera.up

	@of.puts "	Position    #{PRECISION % (eye.x.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (eye.z.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (-eye.y.to_m.to_f * @vdrscale.to_f )}"
	if @pers2p == "yes"#二点透視にする場合シフトでtan移動
		fheight = Math.tan( (@camera.fov / 2).degrees ) * 2
		cdir = @camera.direction.normalize
		lshift = cdir.z / ( ( 1 - cdir.z ** 2 ) ** 0.5 ) / fheight
		@of.puts "	Focus       #{PRECISION % (tar.x.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (eye.z.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (-tar.y.to_m.to_f * @vdrscale.to_f )}"
		@of.puts "	Shift     0.0 #{PRECISION % (lshift)}"
	else
		@of.puts "	Focus       #{PRECISION % (tar.x.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (tar.z.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (-tar.y.to_m.to_f * @vdrscale.to_f )}"
	end
	@of.puts "	Upside      #{PRECISION % cup.x} #{PRECISION % cup.z} #{PRECISION % (-cup.y)}"

	if @camera.perspective?
		#@of.puts "	FocalLength #{PRECISION % (@camera.focal_length.to_m.to_m.to_f) }"#* SCALE_FACTOR.to_f
		p_aspect = @camera.aspect_ratio.to_f
		p_aspect = 1.0 if p_aspect == 0.0
		@of.puts "	FocalLength #{PRECISION % ( @camera.focal_length.to_f * p_aspect / 1000 ) }"
		@of.puts "	FilmSize 0.036"#Sketchupのフィルム縦サイズは36mmと考えないと合わない。
		@of.puts "	FocalRatio  #{PRECISION % @fr.to_f}" if @fr != nil and @fr != ""
		@of.puts "	Distortion  #{PRECISION % @disto.to_f}" if @disto != "1.0"
	else
		@of.puts "	FocalLength 1.0"
		@of.puts "	Distortion  -1.0"
		@of.puts "	FilmSize #{ @camera.height.to_m }"
	end

	if @camlight.to_f != 0
		@of.puts "new PointLight"
		@of.puts "	Intensity #{@camlight.to_f} #{@camlight.to_f} #{@camlight.to_f}"
		@of.puts "	Position    #{PRECISION % (eye.x.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (eye.z.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (- eye.y.to_m.to_f * @vdrscale.to_f )}"
	end
	#バッチファイル用パラメータ 091101変更 @oversampleを再計算しない
	@oversample = @osbase#(@osbase.to_i + 4096 * (@camera.focal_length.to_m * SCALE_FACTOR )**2).to_i
	@bat_arealight=@gi.to_i
	@bat_pointlight=@gi.to_i
	@bat_parallellight=@gi.to_i

	#export Sun
	sinfo = Sketchup.active_model.shadow_info
	sd = sinfo["SunDirection"]
	s_ymdt = sinfo["ShadowTime"]
	st = s_ymdt.to_s.split(" ")[3]
	tz = sinfo["TZOffset"]

	output_light_code = []

	if @use_sun == "yes"
		output_light_code.push "new ParallelLight"
		output_light_code.push "	Emission  1.0 1.0 1.0"
		output_light_code.push "	Direction #{PRECISION % sd.x} #{PRECISION % sd.z} #{PRECISION % (-sd.y)}"
	elsif @use_sun == "real"
		#太陽の照度     晴天時昼 100000 lx ～晴天時昼マイナス2時65000　～晴天時昼プラス2時 35000 ～ 曇天時昼 32000 lx　～日没時 300 lx
		#太陽の色温度度 晴天時昼 12000 k   ～ 曇天時 6500 k 　 ～日没時 2400 k
		#通常室内照明で得ている照度を500lxと仮定（実際には不明であるが）すると65000/500 = 100倍?
		#曇天時の昼で32000なので周辺光としては…？
		#曇天時の天空の照度分布は天頂部と周辺部で3倍程度の違いとなる。曇天時の周辺は10600 という比率と仮定する。
		#晴天時の周辺はその半分しか残らないと仮定して5300/500=10倍?
		output_light_code.push "new ParallelLight"
		output_light_code.push "	Emission  2.0 2.0 2.0"
		output_light_code.push "	Direction #{PRECISION % sd.x} #{PRECISION % sd.z} #{PRECISION % (-sd.y)}"
	end
	output_light_code.each{|e| @of.puts e }
	
	if @s2v_volumes.length != nil
		@s2v_volumes.each{|vol|
			if vol[0] != ""
			@of.puts 'new Volume "' + vol[0] + '"'
			@of.puts '	Extinction	0 0 0'
			@of.puts '	Albedo		0 0 0'
			@of.puts '	HomogeneousExtinction	' + vol[1]
			@of.puts '	HomogeneousAlbedo	' + vol[2]
			@of.puts '	Anisotropy		' + vol[3]
			#output_light_code.each{|e| @of.puts e }
			end
		}
	end
	
	gmf = File.new(@geomfile, "r")
	gmf.each{|line_gmf|
		@of.puts line_gmf
	}
	gmf.close

	if sec_t != nil
		#o_sec = sec_t * Geom::Point3d.new(0,0,0)
		@of.puts "new Object"
		@of.puts "	File \"su2objmtlsec.obj\""
		@of.puts "	Position #{PRECISION % ( cpt2.x.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % ( cpt2.z.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (-cpt2.y.to_m.to_f * @vdrscale.to_f )}"
		@of.puts "	Material \"VDR_JUMP1\""
		axis = sec_t * Geom::Vector3d.new(1,0,0)
		@of.puts "	X #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
		axis = sec_t * Geom::Vector3d.new(0,0,1)
		@of.puts "	Y #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
		axis = sec_t * Geom::Vector3d.new(0,-1,0)
		@of.puts "	Z #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
		o_sec = cpt2 + svec_N
		@of.puts "new Object"
		@of.puts "	File \"su2objmtlsec.obj\""
		@of.puts "	Position #{PRECISION % ( o_sec.x.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % ( o_sec.z.to_m.to_f * @vdrscale.to_f ) } #{PRECISION % (-o_sec.y.to_m.to_f * @vdrscale.to_f )}"
		@of.puts "	Material \"VDR_JUMP2\""
		axis = sec_t * (Geom::Vector3d.new 1,0,0)
		@of.puts "	X #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
		axis = sec_t * (Geom::Vector3d.new 0,0,1)
		@of.puts "	Y #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
		axis = sec_t * (Geom::Vector3d.new 0,-1,0)
		@of.puts "	Z #{PRECISION % ( axis.x.to_f * @vdrscale.to_f ) } #{PRECISION % ( axis.z.to_f * @vdrscale.to_f ) } #{PRECISION % (-axis.y.to_f * @vdrscale.to_f ) }"
	end
	Sketchup.active_model.materials.each{|mat|
		export_volume( mat , @of )
	}
	@of.flush
	@of.close
	tt = ( st.split(":")[0].to_i + tz.to_i + 22 ).to_i % 24
	mm = st.split(":")[1]
	@title = @title + "-Time_#{0.to_s if tt < 10}#{tt.to_s}#{mm}"
	@title = @title + "-GI_#{@gi.to_s}-OS_#{@oversample.to_s}"

	#@camera.aspect_ratio = p_aspect
	#@camera.focal_length = p_flength
	end

	def export_object_file( mat, objname = "" ,mesh_st_en = "", tr = nil)
	#  @export_dir　共用エクスポート用ディレクトリ
	#  @scenefile:scene file 		共用シーンファイル名
	#  @objfile  :object file 		共用オブジェクトファイル名
	#  @mtlfile  :material file 	共用マテリアルライブラリファイル名
	#  PRECISION ：precision		共用数値フォーマット（小数点桁）
	#  SCALE_FACTOR:scale factor	共用スケール（インチをメートル）
	#  objname	:object name				今回のコンポーネントおよびグループ名
	#  objfile	:object file textstream		今回のオブジェクトファイル名
	#  tr		：object transformation		今回の変形度 

	#  @meshes メッシュリスト	マテリアルごとのハッシュ
	#  @vts = vts	点リスト
	#  @uvs = uvs	UV座標リスト
	#  @nos = nos	法線リスト
	#Sketchup.set_status_text "export object to file"

	o = Geom::Transformation.new
	o = tr if tr != nil
	#@objfile = File.join(@export_dir,(File.basename(@scenfile) + "_obj." + @obj_ext)) if @objfile == nil
	objfile = File.join(@export_dir,(objname + ".obj"))
	if @of == nil
	@of = File.new(objfile, "w")
	@of.puts "mtllib #{@mtllib}"
	end
	matname = "default_mat"
	if mat != nil
		matname = enc_kconv(mat.name)
	end
	matname = "default_mat" if matname == ""
	@of.puts "g grp-#{matname}" if matname != nil
	@of.puts "usemtl #{matname}" if matname != nil# and matname != "default_mat"
	return if @meshes == nil
	if @meshes.length != 0 and @vts.length != 0
	    
	    @v_cnt = 0 if @v_cnt == nil

		@vts.each do |vt|
			@of.puts "v #{PRECISION % vt.x.to_m.to_f} #{PRECISION % vt.z.to_m.to_f} #{PRECISION % (-vt.y.to_m.to_f)}"
		end
		@uvs.each do |vuv|
			uv = vuv[1]
		 	@of.puts "vt #{PRECISION % (uv.x)} #{PRECISION % (uv.y)}"
		end
		@nos.each do |vnor|
			nor = vnor[1]
			if @smooth == "yes"
			 	@of.puts "vn #{PRECISION % (nor.x)} #{PRECISION % (nor.z)} #{PRECISION % (-nor.y)}"
			end
		end
		useplight = matname[/POINTLIGHT(\d*).*/]
		useslight = matname[/SPOTLIGHT(\d*).*/]
	    emis = 1
	    emis = $1.to_f/ 100.00 if $1
		usesrad = matname[/RADIUS(\d*).*/]
		sprad = 0
		sprad = $1.to_i if $1
		sprad = 180 if sprad >= 180
		usesfall = matname[/FALLOFF(\d*).*/]
		spfal = 0
		spfal = $1 if $1

		if useplight or useslight
			cpt = Geom::Point3d.new
			@vts.each do |vt|
				#vt = o * vta
				cpt = cpt + Geom::Vector3d.new(vt.x.to_m,vt.y.to_m,vt.z.to_m)
			end
			tsc = (1.00/(@vts.length.to_f)).to_f
			cpt.x = cpt.x * tsc.to_f
			cpt.y = cpt.y * tsc.to_f
			cpt.z = cpt.z * tsc.to_f
			#UI.messagebox cpt.to_s + tsc.to_s
			nvec = Geom::Vector3d.new
			@nos.each do |vnor|
				nor = vnor[1]
				#nor = o * nor
				nvec = nvec + nor
			end
			#tsc = 1/(@nos.length)
			nvec.normalize!
			clr = Sketchup::Color.new(255, 255, 255)
			clr = mat.color if mat != nil
			@store_pointlight.push([cpt,objname,nvec,emis,sprad,spfal,clr])
			#if objname != ""
		else
			@meshes.each_with_index{|mesh,ms_cnt|
				Sketchup.set_status_text "export count:#{ms_cnt}/#{@meshes.length} faces" if ( ms_cnt & 1000 ) == 0
				mesh.each do |pg|
					f_str = "f"
					pg.each{|j|
						k = j + @v_cnt
						#if matname[0,6] == "PORTAL"
						#	f_str += " #{k}" if @smooth != "yes"
						#	f_str += " #{k}//#{k}" if @smooth == "yes"
						#else
							f_str += " #{k}/#{k}" if @smooth != "yes"
							f_str += " #{k}/#{k}/#{k}" if @smooth == "yes"
						#end
					}
					@of.puts f_str
				end
			}
		end
		@v_cnt += @vts.length if @vts.length > 0
	end
	#Fur マクロから追加
	fur =false
	if fur == true
		fur = FUR_EN.new ####create new FUR_EN class
		oocnt = 0
		@faces.each{|oface|
			ret_furmesh = []
			if fur.get_furmesh_by_mat( oface , mat , ret_furmesh ) != nil ###get furmesh array::ret_furmesh = [ polymesh , uv ]
				@of.puts "FurMesh #{oocnt}"
				ret_furmesh.each{|mesh , uv|
					if mesh != nil
						(1..(mesh.count_points)).each{|indx|
							vt = mesh.point_at(indx)
							nor = mesh.normal_at(indx)
							@of.puts "v #{PRECISION % vt.x.to_m.to_f} #{PRECISION % vt.z.to_m.to_f} #{PRECISION % (-vt.y.to_m.to_f)}"
							@of.puts "vn #{PRECISION % nor.x} #{PRECISION % nor.z} #{PRECISION % (-nor.y)}"
							@of.puts "vt #{PRECISION % uv.x} #{PRECISION % uv.y}"
						#現状のsu2objmtlの書式だとvもvnもvtも同じインデックスを使うのでそのままuvも同数増やす
						}
						
						mesh.polygons.each{|pg|
							f_str = "f"
							pg.each{|px|
								k = px + @v_cnt 
								f_str += " #{k}/#{k}/#{k}"
							}
							@of.puts f_str
						}
						@v_cnt = @v_cnt + mesh.count_points
						oocnt += mesh.count_points
					end
				}
			end
		}
	end
	#Sketchup.set_status_text "Making Fur #{oocnt} polygons"
	#OBJファイルを閉じるか？
	if mesh_st_en == "end" and @of != nil
		@v_cnt = nil
		@of.close
		@of = nil
	end
	@meshes = nil
	@uvs = nil
	@nos = nil
	@vts = nil
	end
	def get_mat_property_att( props )
		@emis = props["emis"]
		@refl= props["refl"]
		@refl_ior = props["refl_ior"]
		@spec = props["spec"]
		@spec_refl = props["spec_refl"]
		@axis_x = props["axis_x"]
		@axis_y = props["axis_y"]
		@axis_z = props["axis_z"]
		@ior_front = props["ior_front"]
		@ior_back = props["ior_back"]
		@exp_u = props["exp_u"]
		@exp_v = props["exp_v"]
		@emis_map = props["emis_map"]
		@emis_dstr = props["emis_dstr"]
		@portal = props["portal"]
		@refl_map = props["refl_map"]
		@normal_map = props["normal_map"]
		@spec_map = props["spec_map"]
		@trans_map = props["trans_map"]
		#@volume_front = props["volume_front"]
		#@volume_back = props["volume_back"]
		@jump1 = props["@jump1"]
		@jump2 = props["@jump2"]
		@background = props["@background"]
	end
	def export_mtl_material()
	#  @export_dir　共用エクスポート用ディレクトリ
	#  @scenefile:scene file 		共用シーンファイル名
	#  @objfile  :object file 		共用オブジェクトファイル名
	#  @mtlfile  :material file 	共用マテリアルライブラリファイル名
	#  PRECISION ：precision		共用数値フォーマット（小数点桁）
	#  SCALE_FACTOR:scale factor	共用スケール（インチをメートル）

		defdif = @defcolor.split(" ").collect{|dd| (dd.to_f)** 2.2 }.join(" ")
		defdif = "0.65 0.65 0.65" if @clay == "yes"
		@of.puts "new Material \"default_mat\""
		@of.puts "	Diffuse " + defdif

		if @enemi.to_f != 0
			@of.puts "	Emission	" + (@enemi.to_f.to_s + " " ) * 3
		end
		@of.puts 'new Material "VDR_JUMP1"'
		@of.puts "	Transparency	1.0 1.0 1.0"
		@of.puts "	IOR			1.0 1.0"
		@of.puts '	Jump "VDR_JUMP2" "VDR_JUMP2"'
		@of.puts 'new Material "VDR_JUMP2"'
		@of.puts "	Transparency	1.0 1.0 1.0"

		@of.puts "	IOR			1.0 1.0"
		@of.puts '	Jump "VDR_JUMP1" "VDR_JUMP1"'
		@s2v_used_material.uniq!
		@s2v_volumes = []

		@s2v_used_material.each{|mat|
			next if mat == nil
			matname = enc_kconv( mat.name )
			@emis = -1
			@emis = @enemi.to_f * 100.0 if @enemi.to_f != 0
			@refl = -1
			@spec = -1
			@ior = -1
			@back = -1
			@bump = -1
			@rough = -1
			@urough = -1
			@vrough = -1
			@sgm = -1
			@cauchy = -1
			props = nil
			mat_attdics =  mat.attribute_dictionaries
			props = mat.attribute_dictionaries[ "vidro_material_setting" ] if mat_attdics
			if not props
				get_mat_expression( matname )#enc_kconv( mat.name )
				export_mtl_material_by_old( mat , matname )
			else
				#get_mat_property_att( props )
				export_mtl_material_by_props( mat , matname , props )
			end
		}
	end
	def export_volume( mat , txtfile )
		return if not mat
		matname = enc_kconv( mat.name )
		mat_attdics =  mat.attribute_dictionaries
		props = mat.attribute_dictionaries[ "vidro_material_setting" ] if mat_attdics
		if props
			if props["use_volume"] == "yes"
				anisto = props["anisto"]
				extinc = props["extinc"]
				albedo = props["albedo"]
				#hm_extinc = props["hm_extinc"]
				#hm_albedo = props["hm_albedo"]
				sky_file = props["sky_file"]
				sky_rgb = props["@sky_rgb"]
				
				txtfile.puts "new Volume \"vol-#{matname}\""
				txtfile.puts "	Origin        0.0 0.0 0.0"
				if anisto != ""
					txtfile.puts "	Anisotropy	#{anisto}"
				end
				if extinc != ""
					txtfile.puts "	HomogeneousExtinction	" + ( "#{extinc} " * 3 )
					#txtfile.puts "	HomogeneousExtinction	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * extinc.to_f ) }.join( " " )
				end
				if albedo != ""
					#txtfile.puts "	HomogeneousAlbedo	" + ( "#{albedo} " * 3 )
					txtfile.puts "	HomogeneousAlbedo	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * albedo.to_f ) }.join( " " )
				end
				#if hm_extinc != ""
					#txtfile.puts "	HomogeneousExtinction	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * hm_extinc.to_f ) }.join( " " )
				#end
				#if hm_albedo != ""
					#txtfile.puts "	HomogeneousAlbedo	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * hm_albedo.to_f) }.join( " " )
				#end
				if sky_file != ""
					sky_rgb = "1 1 1 " if sky_rgb == "0 0 0"
					txtfile.puts "	SkyLight #{sky_rgb} \"#{sky_file}\""
				elsif sky_rgb != ""
					txtfile.puts "	SkyLight #{sky_rgb}"
				end
			end
		end
	end
	def copy_mapfiles()
		model = Sketchup.active_model
		mats = model.materials
		modelpath = Sketchup.active_model.path
		ppdir = File.dirname( modelpath ) if modelpath
		return if not ppdir
		msg = "Files copied"
		mats.each{|mat|
			mat_attdics =  mat.attribute_dictionaries
			props = mat.attribute_dictionaries[ "vidro_material_setting" ] if mat_attdics
			if props
				emis_map = props["emis_map"]
				emis_dstr = props["emis_dstr"]
				portal = props["portal"]
				refl_map = props["refl_map"]
				normal_map = props["normal_map"]
				spec_map = props["spec_map"]
				trans_map = props["trans_map"]
				msg << copy_mapfile_do( emis_map , ppdir )
				msg << copy_mapfile_do( emis_dstr , ppdir )
				msg << copy_mapfile_do( portal , ppdir )
				msg << copy_mapfile_do( refl_map , ppdir )
				msg << copy_mapfile_do( normal_map , ppdir )
				msg << copy_mapfile_do( spec_map , ppdir )
				msg << copy_mapfile_do( trans_map , ppdir )
			end
		}
		UI.messagebox msg
	end
	def copy_mapfile_do( mappath , ppdir )
		if mappath != "" and mappath != "#" and File.exists?( mappath )
			newpath = File.join( ppdir , File.basename( mappath ))
			if not File.exists?( newpath ) and newpath != mappath
				#FileUtils.copy_file( mappath , newpath )
				open(mappath , "r+b" ) {|source|
				  open(newpath, "w+b") {|dest|
					dest.write(source.read)
				  }
				}
				return newpath
			end
		end
	end
	def search_map_file( mappath , ppdir )
		if mappath != "" and mappath != "#" and not File.exists?( mappath ) and ppdir
			newpath = File.join( ppdir , File.basename( mappath ))
			mappath = newpath if File.exists?( newpath )
			mappath.gsub!(/\//,"\\")
			p mappath
			
		end
		return mappath
	end
	def export_mtl_material_by_props( mat , matname, props  )
		diffuse = props["diffuse"]
		emis = props["emis"]
		refl = props["refl"]
		refl_ior = props["refl_ior"]
		spec = props["spec"]
		spec_refl = props["spec_refl"]
		axis_x = props["axis_x"]
		axis_y = props["axis_y"]
		axis_z = props["axis_z"]
		ior_front = props["ior_front"]
		ior_back = props["ior_back"]
		exp_u = props["exp_u"]
		exp_v = props["exp_v"]
		emis_map = props["emis_map"]
		emis_dstr = props["emis_dstr"]
		portal = props["portal"]
		refl_map = props["refl_map"]
		normal_map = props["normal_map"]
		spec_map = props["spec_map"]
		trans_map = props["trans_map"]
		#volume_front = props["volume_front"]
		#volume_back = props["volume_back"]
		use_volume = props["use_volume"]
		jump1 = props["@jump1"]
		jump2 = props["@jump2"]
		background = props["@background"]
		texturename = ""
		modelpath = Sketchup.active_model.path
		ppdir = File.dirname( modelpath ) if modelpath
		emis_map = search_map_file( emis_map , ppdir )
		portal = search_map_file( portal , ppdir )
		emis_dstr = search_map_file( emis_dstr , ppdir )
		refl_map = search_map_file( refl_map , ppdir )
		normal_map = search_map_file( normal_map , ppdir )
		spec_map = search_map_file( spec_map , ppdir )
		trans_map = search_map_file( trans_map , ppdir )
		ior_front = "1.0" if not ior_front or ior_front == ""
		diffuse = "1.0" if not diffuse or diffuse == ""
		
		if mat.texture != nil
			texturename = enc_kconv(File.basename(mat.texture.filename.to_s))
			texturename = @texnames_bymat[mat.name] if @texnames_bymat[mat.name]
			texturename = @textures_prefix + "\\" + texturename if @textures_prefix != ""
		end
		
		@of.puts "new Material \"#{matname}\""
		if emis.to_f > 1.0
			@of.puts "	Diffuse	0 0 0"
		else
			if texturename != ""
				@of.puts "	Diffuse	" + ( "#{diffuse} " * 3 ) + "\"#{texturename}\""
			else
				@of.puts "	Diffuse	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 * diffuse.to_f )** 2.2) }.join( " " )
			end
		end
		if mat.alpha < 1 or trans_map != ""
			trans_map = texturename if trans_map == "#"
			if trans_map != ""
				@of.puts "	Transparency	" + [1,1,1].collect{ |x| "%.6f" % ( ( 1 - mat.alpha ) * (1 - (x.to_f/255)**2.2)) }.join( " " ) + " \"#{trans_map}\""
			else
				@of.puts "	Transparency	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ( ( 1 - mat.alpha ) * ((1- x.to_f / 255 )**2.2)) }.join( " " )
				#@of.puts "	Transparency	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ( ( 1 - mat.alpha ) * ( (x.to_f / 255 )**2.2 )) }.join( " " )
			end
		end
		if ior_front != "" and ior_back != ""
			ior_back = "1.0" if ior_back == ""
			@of.puts "	IOR			#{ior_front} #{ior_back}"
		else
			@of.puts "	IOR			1.0 1.0"
		end
		if emis_map != "" or portal != "" or emis_dstr != ""
			emis = "1.0" if emis == ""
			emis_map = texturename if emis_map == "#"
			@of.puts "	Emission	" + "#{emis} " * 3  +  "\"#{emis_map}\" \"#{emis_dstr}\" \"#{portal}\""
		elsif emis != ""
			@of.puts "	Emission	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * emis.to_f ) }.join( " " )
		else
			
		end
		if refl != "" or refl_map != ""
			refl = "1.0" if refl == ""
			refl_map = texturename if refl_map == "#"
			@of.puts "	Reflection " + "#{refl} " * 3 + "\"#{refl_map}\""
		end
		if refl_ior != ""
			@of.puts "	ReflectionIOR " + "#{refl_ior} " * 3
		end
		spec_refl = "0.5" if spec_refl == ""
		if spec != ""
			if spec_map != ""
				spec = "1.0" if spec == ""
				spec_map = texturename if spec_map == "#"
				@of.puts "	Specular " + "#{spec} " * 3 + "\"#{spec_map}\""
				@of.puts "	SpecularReflectance	" + "#{spec_refl} " * 3
			else
				spec = "1.0" if spec == ""
				spec_map = texturename if spec_map == "#"
				if ( spec.to_f * spec_refl.to_f ) > 1
					@of.puts "	Specular " + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 *  spec.to_f ) }.join( " " )
					@of.puts "	SpecularReflectance	" + "#{spec_refl} " * 3
				else
					@of.puts "	Specular " + "#{spec} " * 3
					@of.puts "	SpecularReflectance	" + "#{spec_refl} " * 3
				end
			end
		end
		if axis_x != "" and axis_y != "" and axis_z != ""
			@of.puts "	Axis	#{axis_x} #{axis_y} #{axis_z}"
		end
		if normal_map != ""
			@of.puts "	Normal \"#{normal_map}\""
		end
		if exp_u != "" and exp_v != ""
			exp_u = "32" if exp_u == ""
			exp_v = "32" if exp_v == ""
			@of.puts "	Exponent	#{exp_u} #{exp_v}"
		end
		if use_volume == "yes"
			@of.puts "	Volume \"vol\" \"vol-#{matname}\""
		end
		if background != "0"
			@of.puts "	Background	#{background}"
		end
	end
	def material_props_by_name( mat )
		matname = enc_kconv( mat.name )
		@ior = 1.0
		@refl = 0.0
		@bump = 0.0
		@emis = 0.0
		@spec = 0.0
		@urough = 0.0
		@vrough = 0.0
		get_mat_expression( matname )
		ior = ""
		refl = ""
		bump = ""
		emis = ""
		spec = ""
		diffuse = "1.0"
		texturename = ""
		spec_refl = ""
		exp = ""
		uexp = ""
		vexp = ""
		extinc = ""
		albedo = ""
		anisto = ""
		ior_front = ""
		ior_back = ""
		refl_ior = ""
		trans_map = ""
		refl_map = ""
		spec_map = ""
		emis_map = ""
		jump1 = ""
		jump2 = ""

		ior_back = @ior.to_s if @ior
		refl = @refl.to_s if @refl > 0.0
		bump = @bump.to_s if @bump > 0.0
		emis = @emis.to_s if @emis > 0.0
		emis_map = "#" if @emis > 0.0
		spec = @spec.to_s if @spec > 0.0
		spec_map = "#" if @spec > 0.0
		uexp = "#{@urough * 100}" if @urough > 0.0
		vexp = "#{@vrough * 100}" if @vrough > 0.0
		#p @vrough
		usespref = matname[/.*SPREF(\d*).*/]
		spec_refl = "#{$1.to_f / 100}" if $1
		useextinc = matname[/.*EXTINC(\d*).*/]
		extinc = "#{$1.to_f / 100}" if $1
		usealbedo = matname[/.*ALBEDO(\d*).*/]
		albedo = "#{$1.to_f / 100}" if $1
		useaniso = matname[/.*ANISO(\d*).*/]
		anisto = "#{$1.to_f / 100 - 1}" if $1
		useuexp = matname[/.*UEXP(\d*).*/]
		uexp = "#{$1.to_f}" if $1
		usevexp = matname[/.*VEXP(\d*).*/]
		vexp = "#{$1.to_f}" if $1
		useexp = matname[/.*EXP(\d*).*/]
		exp = "#{$1.to_f}" if $1
		useback = matname[/.*BACK(\d*).*/]
		background = "#{$1.to_i}" if $1
		background = "0" if not $1
		background = "0" if background.to_f > 2
		use_volume = "no"

		if mat.texture != nil
			texturename = enc_kconv(File.basename(mat.texture.filename.to_s))
		end
		if matname[/.*THINGLASS.*/]
			#trans_map = "#" if not texturename == ""
			ior_front = "1.0"
			ior_back = "1.0"
			refl = "0.1" if refl == ""
		elsif matname[/.*ROUGHGLASS.*/]
			#trans_map = "#" if not texturename == ""
			ior_front = "1.0"
			ior_back = "1.5"
			uexp = "8" if uexp == ""
			vexp = "8" if vexp == ""
			spec = "0.2" if spec == ""
			refl = "0.1" if refl == ""
		elsif matname[/.*GLASS.*/]
			#trans_map = "#" if not texturename == ""
			ior_front = "1.0"
			ior_back = "1.5"
			refl = "0.1" if refl == ""
		elsif matname[/.*ALUMI.*/]
			spec_refl = "1.0" if spec_refl == ""
		elsif matname[/.*JUMP1.*/]
			jump1 = "JUMP2"
			jump2 = "JUMP2"
			ior_front = "1.0"
			ior_back = "1.0"
		elsif matname[/.*JUMP2.*/]
			jump1 = "JUMP1"
			jump2 = "JUMP1"
			ior_front = "1.0"
			ior_back = "1.0"
		else
			if mat.name[0,9] == "CIELLIGHT"
				useemis = matname[/.*CIELLIGHT(\d*).*/]
				emis = $1 if $1
				emis = "1" if emis == ""
				#emis_map = "#" if texturename == ""
			elsif mat.name[0,9] == "SOFTLIGHT"
				#emis_map = "#" if texturename == ""
				emis = "1"
			elsif mat.name[0,9] == "HARDLIGHT"
				#emis_map = "#" if texturename == ""
				emis = "10"
			else
				if matname[/.*SUBSTRATE.*/]
					uexp = "32" if uexp == ""
					vexp = "32" if vexp == ""
					spec = "0.2" if spec == ""
				elsif matname[/.*GLOSSY.*/] or matname[/.*SHINY.*/]
					uexp = "32" if uexp == ""
					vexp = "8" if vexp == ""
					spec = "0.2" if spec == ""
				end
			end#
			if matname[/.*MTRANS.*/] or matname[/.*STRANS.*/]
				use_volume = "yes"
				ior_back = "1.33" if ior_front == ""
			end
		end
		#ior_back = ior if ior != ""
		if refl and ior_back
		if refl.to_f >= 1 and ior_back.to_f >= 1 then
			refl_ior = ior_back
		end
		end
		spec_refl = "1.0" if spec_refl.to_f > 1.0
		if refl_ior.to_f > 1.0
			diffuse = "0.1"
		end
		normal_map = "#" if bump != "" and texturename != ""
		props = Hash.new
		props["diffuse"] = diffuse.to_s
		props["emis"] = emis.to_s
		props["refl"] = refl.to_s
		props["refl_ior"] = refl_ior.to_s
		props["spec"] = spec.to_s
		props["spec_refl"] = spec_refl.to_s
		props["ior_front"] = ior_front.to_s
		props["ior_back"] = ior_back.to_s
		props["exp_u"] = uexp.to_s
		props["exp_v"] = vexp.to_s
		props["emis_map"] = emis_map.to_s
		props["refl_map"] = refl_map.to_s
		props["normal_map"] = normal_map.to_s
		props["spec_map"] = spec_map.to_s
		props["trans_map"] = trans_map.to_s
		props["use_volume"] = use_volume.to_s
		props["@jump1"] = jump1.to_s
		props["@jump2"] = jump2.to_s
		props["@background"] = background.to_s
		props["extinc"] = extinc.to_s
		props["albedo"] = albedo.to_s
		props["anisto"] = anisto.to_s

		return props
		#.each{|key,val|
		#	if val
		#		mat.set_attribute( "vidro_material_setting", key, val )
		#	end
		#}

	end
	def export_mtl_material_by_old( mat , matname )
		texturename = ""
		spref = 0.5
		exp = -1
		uexp = -1
		vexp = -1
		extinc = 10 / @vdrscale
		albedo = 0.8
		aniso = 0.2
		usespref = matname[/.*SPREF(\d*).*/]
		spref = $1.to_f / 100 if $1
		useextinc = matname[/.*EXTINC(\d*).*/]
		extinc = $1.to_f / 100 if $1
		usealbedo = matname[/.*ALBEDO(\d*).*/]
		albedo = $1.to_f / 100 if $1
		useaniso = matname[/.*ANISO(\d*).*/]
		aniso = $1.to_f / 100 - 1 if $1
		useuexp = matname[/.*UEXP(\d*).*/]
		uexp = $1.to_f if $1
		usevexp = matname[/.*VEXP(\d*).*/]
		vexp = $1.to_f if $1
		useexp = matname[/.*EXP(\d*).*/]
		exp = $1.to_f if $1
		useback = matname[/.*BACK(\d*).*/]
		back = $1.to_i if $1
		back = 0 if not $1
		back = 0 if back > 2
		@of.puts "new Material \"#{matname}\""

		texturename = ""
		if mat.texture != nil
			texturename = enc_kconv(File.basename(mat.texture.filename.to_s))
			texturename = @texnames_bymat[mat.name] if @texnames_bymat[mat.name]
			texturename = @textures_prefix + "\\" + texturename if @textures_prefix != ""
		end

		if matname[/.*THINGLASS.*/]
			@of.puts "	Transparency	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % (1 - mat.alpha * (1 - (x.to_f/255)**2.2)) }.join( " " ) if texturename == ""
			@of.puts "	Transparency	1.0 1.0 1.0 \"#{texturename}\"" if not texturename == ""
			@of.puts "	IOR			1.0 1.0"
			@refl = 0.1 if @refl <= 0
		elsif matname[/.*ROUGHGLASS.*/]
			@of.puts "	Transparency	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % (1 - mat.alpha * (1 - (x.to_f/255)**2.2)) }.join( " " ) if texturename == ""
			@of.puts "	Transparency	1.0 1.0 1.0 \"#{texturename}\"" if not texturename == ""
			@of.puts "	IOR			1.0 1.5"
			@urough = 0.08 if @urough <= 0
			@vrough = 0.08 if @vrough <= 0
			@spec = 0.2 if @spec <= 0
			@refl = 0.1 if @refl <= 0
		elsif matname[/.*GLASS.*/]
			@of.puts "	Transparency	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % (1 - mat.alpha * (1 - (x.to_f/255)**2.2)) }.join( " " ) if texturename == ""
			@of.puts "	Transparency	1.0 1.0 1.0 \"#{texturename}\"" if not texturename == ""
			@of.puts "	IOR			1.0 1.5"
			@refl = 0.1 if @refl <= 0
		elsif matname[/.*ALUMI.*/]
			spref = 1.0 if spref <= 1.0
		elsif matname[/.*JUMP1.*/]
			@of.puts "	Transparency	1.0 1.0 1.0"
			@of.puts '	Jump "JUMP2" "JUMP2"'
			@of.puts '	Volume "vol" "vol"'
			@of.puts '	IOR 1 1'
		elsif matname[/.*JUMP2.*/]
			@of.puts "	Transparency	1.0 1.0 1.0"
			@of.puts '	Jump "JUMP1" "JUMP1"'
			@of.puts '	Volume "vol" "vol"'
			@of.puts '	IOR 1 1'
		else
			if @clay == "no"
				if mat.name[0,9] == "CIELLIGHT"
					useemis = matname[/.*CIELLIGHT(\d*).*/]
					@emis = $1.to_f if $1
					@emis = 100 if @emis == 0
					portalmap = File.join( File.dirname( File.expand_path(__FILE__) ), "su2objmtl" , "portal_map.png" )
					#Sketchup.find_support_file( "portal_map.png", "Plugins/su2objmtl/" )
					if texturename == ""
						lightcolor = mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * @emis / 100 ) }.join( " " ) 
						@of.puts "	Emission	#{lightcolor} \"\" \"\" \"#{portalmap}\""
					else
						@of.puts "	Emission	1.0 1.0 1.0 \"#{texturename}\" \"\" \"#{portalmap}\""
					end
				elsif mat.name[0,9] == "SOFTLIGHT"
					@of.puts "	Emission	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * 50) }.join( " " ) if texturename == ""
					@of.puts "	Emission	1.0 1.0 1.0 \"#{texturename}\"" if not texturename == ""
					@emis = 100
				elsif mat.name[0,9] == "HARDLIGHT"
					@of.puts "	Emission	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * 100) }.join( " " ) if texturename == ""
					@of.puts "	Emission	100.0 100.0 100.0 \"#{texturename}\"" if not texturename == ""
					@emis = 100
				elsif mat.name[0,6] == "PORTAL"
					@useportal = true
					@of.puts "	Emission	1.0 1.0 1.0 \"\" \"\" \"#{@ibl_file}\""
				else
					if matname[/.*SUBSTRATE.*/]
						@urough = 0.32 if @urough <= 0
						@vrough = 0.32 if @vrough <= 0
						@spec = 0.2 if @spec <= 0
					elsif matname[/.*GLOSSY.*/] or matname[/.*SHINY.*/]
						@urough = 0.32 if @urough <= 0
						@vrough = 0.08 if @vrough <= 0
						@spec = 0.2 if @spec <= 0
					end
					if texturename != ""
						#if @bump >= 0
						#	if matname[/.*DBUMP.*/]
						#		@of.puts "	Diffuse	1.0 1.0 1.0 \"#{texturename}\""
						#		@of.puts "	Normal	\"#{texturename}\""
						#	else
						#		@of.puts "	Diffuse	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2) }.join( " " )
						#		@of.puts "	Normal	\"#{texturename}\"" 
						#	end
						#else
						if ( spref ) >= 1.0
							@of.puts "	Diffuse	0.01 0.01 0.01"
						else
							if matname[/.*DBUMP.*/]
								@of.puts "	Diffuse	1.0 1.0 1.0"
							else
								@of.puts "	Diffuse	1.0 1.0 1.0 \"#{texturename}\""
							end
						end
						if @emis >= 0
							@of.puts "	Emission	" + (" "+ (@emis.to_f/100).to_s ) * 3 + "\"#{texturename}\""
						#elsif @enemi != 0
						#	@of.puts "	Emission	" + (" " + @enemi.to_s) * 3 + "\"#{texturename}\""
						end
						#end
					else
						#if spref == 0.5
						#else
						if ( spref ) >= 1.0
							@of.puts "	Diffuse	0.01 0.01 0.01"
						elsif @emis >= 1.0
							@of.puts "	Diffuse	0 0 0"
						else
							@of.puts "	Diffuse	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2) }.join( " " )
						end

						#elsif spref <= 1.0
						#	@of.puts "	Diffuse	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * ( 1.0 - spref.to_f )) }.join( " " )
						#else
						#	@of.puts "	Diffuse	0.0 0.0 0.0"
						#end

						if @emis >= 0
							@of.puts "	Emission	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * @emis / 100) }.join( " " )
						#elsif @enemi != 0
						#	@of.puts "	Emission	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % (((x.to_f/255 )** 2.2) * @enemi.to_f) }.join( " " )
						end
					end
				end#
				if matname[/.*MTRANS.*/] or matname[/.*STRANS.*/]
					@of.puts "	Transparency	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % (1 - ( mat.alpha ** 2.0 )) }.join( " " )# if texturename == ""
					@of.puts '	Volume		"vol" "inner-' + matname + '"'
					#@of.puts '	IOR		1 1'
					@ior = 1.33 if @ior < 0
					#homo_extinc = mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 ) * extinc) }.join( " " )
					homo_extinc = (" " + ( "%.4f" % extinc.to_f ) ) * 3
					#homo_albedo = mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 ) ** 2.2 * albedo) }.join( " " )
					#homo_extinc = mat.color.to_a[0..2].collect{ |x| "%.6f" % ((1 - ( x.to_f/255 ** 2.2)) * extinc) }.join( " " )
					homo_albedo = mat.color.to_a[0..2].collect{ |x| "%.3f" % ((x.to_f/255 ) * albedo) }.join( " " )
					@s2v_volumes.push ["inner-" + matname , homo_extinc, homo_albedo, aniso.to_s ]
				elsif mat.use_alpha?
					@of.puts "	Transparency	" + mat.color.to_a[0..2].collect{ |x| "%.6f" % (1 - mat.alpha) }.join( " " )# if texturename == ""
					#@of.puts "	Transparency	1.0 1.0 1.0 \"#{texturename}\"" if not texturename == ""
				end
			else#clay== true
				
				if @emis >= 1
					@of.puts "	Diffuse 0 0 0"
				elsif @emis >= 0
					@of.puts "	Diffuse " + defdif

					@of.puts "	Emission	" + defdif.split(" ").collect{|x| "&.6f" % ( x.to_f * @emis / 100 )}.join(" ")
				#elsif @enemi != 0
				#	@of.puts "	Emission	" + defdif.split(" ").collect{|x| "&.6f" % ( x * @enemi )}.join(" ")
				else
					@of.puts "	Diffuse " + defdif
				end
				@ior = -1
				@refl = -1
				@spec = -1
				@rough = -1
				@urough = -1
				@vrough = -1
				uexp = -1
				exp = -1
			end#clay
		end
		@of.puts "	IOR 1.0" + (("%.6f" % @ior).to_s) if @ior >= 0
		@of.puts "	Reflection " + (("%.6f" % @refl).to_s + " ") * 3 if @refl >= 0
		if @refl >= 1 and @ior >= 1 then
			@of.puts "	ReflectionIOR " + (("%.6f" % @ior).to_s + " " ) * 3
		end
		spref = 1.0 if spref > 1.0
		if spref == 0.5
			@of.puts "	Specular " + (("%.6f" % @spec).to_s + " ") * 3 if @spec >= 0
		elsif ( spref.to_f * @spec.to_f ) < 1.0
			@of.puts "	Specular " + (("%.6f" % @spec).to_s + " ") * 3 if @spec >= 0
			@of.puts "	SpecularReflectance " + (("%.6f" % spref).to_s + " ") * 3 if spref != 0.5
		else
			#スペキュラが非常に強いときは、色をスペキュラーに掛ける
			if texturename == ""
			@of.puts "	Specular " + mat.color.to_a[0..2].collect{ |x| "%.6f" % ((x.to_f/255 )** 2.2 * @spec.to_f ) }.join( " " ) if @spec >= 0
			@of.puts "	SpecularReflectance	" + (("%.6f" % spref).to_s + " ") * 3
			else
			@of.puts "	Specular " + (("%.6f" % @spec).to_s + " ") * 3 + "\"#{texturename}\"" if @spec >= 0
			@of.puts "	SpecularReflectance	" + (("%.6f" % spref).to_s + " ") * 3
			end
		end

		@of.puts "	Normal \"#{texturename}\"" if @bump >= 0 and texturename != ""
		if @urough >= 0 and @vrough >= 0
			@of.puts "	Exponent	#{@urough * 100} #{@vrough * 100}"
		elsif @rough >= 0
			@of.puts "	Exponent	#{@rough * 100 } #{@rough * 100}"
		elsif uexp >= 0 and vexp >= 0
			@of.puts "	Exponent	#{uexp} #{vexp}"
		elsif exp >= 0
			@of.puts "	Exponent	#{exp} #{exp}"
		end
		#of.puts "	Background	#{back}" if back != 0
	end

end

unless file_loaded?("su2objmtl_vidro.rb")# File.basename(__FILE__)
  su2vdr = SU2VIDRO.new
  main_menu = UI.menu("Plugins").add_submenu("Vidro Render Exporter")
  main_menu.add_item("Export Settings") { su2vdr.render_show_webdialog }
  main_menu.add_item("Material Editor") { su2vdr.material_edit_show_webdialog }
  main_menu.add_item("Copy Mapfiles to Model Directory") { su2vdr.copy_mapfiles }
  main_menu.add_item("Updated:2013.02.19.") { }
  #main_menu.add_item("Material Catalog") { su2vdr.material_list_webdialog }
  #main_menu.add_item("Material Thumb Make") { su2vdr.make_material_thumb }
end

file_loaded("su2objmtl_vidro.rb")